import { system, world } from "@minecraft/server";

const recipes = [
    {
        output: "banana_split",
        ingredients: [
            { item: "ww_dx:ice_cream", count: 1 },
            { item: "ww_dx:banana", count: 1 },
            { item: "ww_dx:chocolate", count: 1 },
            { item: "ww_dx:cherry", count: 1 },
        ],
    },
    {
        output: "chocolate_ice_cream",
        ingredients: [
            { item: "ww_dx:ice_cream", count: 1 },
            { item: "ww_dx:chocolate", count: 1 },
        ],
    },
    {
        output: "ice_cream",
        ingredients: [
            { item: "ww_dx:cream", count: 1 },
            { item: "minecraft:milk_bucket", count: 1 },
            { item: "minecraft:ice", count: 1 },
        ],
    },
    {
        output: "ice_cream_sandwich",
        ingredients: [
            { item: "minecraft:cookie", count: 2 },
            { item: "ww_dx:ice_cream", count: 1 },
        ],
    },
];

const ice_cream_maker = new Map(); 

function processIceCreamMakerInventory(entity) {
    const id = entity.id;


    if (ice_cream_maker.get(id)?.isProcessing) {
        return;
    }

    const inventoryComponent = entity.getComponent("minecraft:inventory");

    if (!inventoryComponent || !inventoryComponent.container) {
    
        return;
    }

    const inventory = inventoryComponent.container;

    for (const recipe of recipes) {

        let matches = true;

        const ingredientsMap = new Map(
            recipe.ingredients.map((ingredient) => [ingredient.item, ingredient.count])
        );

        for (let i = 0; i < inventory.size; i++) {
            const item = inventory.getItem(i);
            if (item) {
                if (ingredientsMap.has(item.typeId)) {
                    const remainingCount = ingredientsMap.get(item.typeId) - item.amount;
                    if (remainingCount <= 0) {
                        ingredientsMap.delete(item.typeId);
                    } else {
                        ingredientsMap.set(item.typeId, remainingCount);
                    }
                } else {
                    matches = false;
                    break;
                }
            }
        }

        if (matches && ingredientsMap.size === 0) {
            entity.runCommandAsync("summon ww_dx:processing_particle ~ ~1 ~")

            for (const ingredient of recipe.ingredients) {
                let remainingToRemove = ingredient.count;

                for (let i = 0; i < inventory.size; i++) {
                    const item = inventory.getItem(i);
                    if (item && item.typeId === ingredient.item) {
                        if (item.amount > remainingToRemove) {
                            item.amount -= remainingToRemove;
                            inventory.setItem(i, item);
                            break;
                        } else {
                            remainingToRemove -= item.amount;
                            inventory.setItem(i, undefined);
                        }
                    }
                }
            }



            ice_cream_maker.set(id, { isProcessing: true });
            system.runTimeout(() => {
                if (!entity.isValid()) return;
                const { x, y, z } = entity.location;
                entity.runCommandAsync(`loot spawn ${x} ${y + 1} ${z} loot ${recipe.output}`);
                entity.runCommandAsync("event entity @e[type=ww_dx:processing_particle,r=1] ww_dx:despawn")
                entity.runCommandAsync("playsound ww_dx:finish_cooking @a[r=5]")
               
                ice_cream_maker.set(id, { isProcessing: false });
            }, 200);

            return; 
        } else {
          
        }
    }


}

let worldInitialize = false;
world.afterEvents.playerSpawn.subscribe((event) => {
    worldInitialize = true;

})
function checkIceCreamMaker() {
    if(!worldInitialize)return;
    const currentDimension = world.getDimension(world.getPlayers()[0].dimension.id);

    for (const entity of currentDimension.getEntities()) {
        if (entity.typeId === "ww_dx:ice_cream_maker") {
            if (!ice_cream_maker.has(entity.id)) {
                ice_cream_maker.set(entity.id, { isProcessing: false });
 
            }

            processIceCreamMakerInventory(entity);
        }
    }
}


system.runInterval(() => {
    checkIceCreamMaker();
}, 20); 
